      Subroutine bsbpk (u,b,n,ifail,log)
c
c  SCOPO: risoluzione di un sistema lineare U*x=b, con matrice
c         dei coefficienti U di tipo triangolare superiore.
c 
c  PARAMETRI DI INPUT:  
c 
c  - u,  vettore di reali,  elementi del triangolo superiore
c  - b,  vettore di reali,  termini noti
c  - n,            intero,  ordine del sistema
c 
c  PARAMETRI DI OUTPUT:
c
c  -     b,  vettore di reali,  soluzione del sistema
c  - ifail,            intero,  indicatore di errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna
c
       integer n,ifail,log
       real u(n*(n+1)/2),b(n)

      

c  Controllo della dimensione 
       if (n .le. 0) then 
          ifail=3
          goto 999
       endif

      write(log,*)' controllo della singolarit'                                                       
c  Controllo della singolarit 
       id=n*(n+1)/2 + 1                         
       write(log,*)'id = ',id
       
       do i=1,n                           
          id=id-i               
          write(log,*)'u(',id,') ',u(id)
          if (u(id) .eq. 0) then
             ifail=4
             goto 999
          endif
       end do

      write(log,*)'backward sub'
c  Backward Substitution        

       iu=n*(n+1)/2 + 1
       write(log,*)'iu =',iu
       write(log,*)'i    j    iu    b(i)'
       do i=n,1,-1
          do j=n,i+1,-1
             iu=iu-1
             b(i)=b(i)-u(iu)*b(j)   
       write(log,*)i,j,iu,b(i)
          end do
          iu=iu-1
          b(i)=b(i)/u(iu)
       end do
         
       ifail=0
  
  999  continue
  
       end
       stop      