      Subroutine conwt(x,y,n,a,ifail)
c
c  SCOPO: calcolo dei coefficienti del polinomio interpolante 
c         nella forma di Newton.
c        
c  PARAMETRI DI INPUT:  
c 
c  - x,  vettore di reali,  ascisse dei punti di interpolazione
c  - y,  vettore di reali,  ordinate dei punti di interpolazione
c  - n,            intero,  numero di punti di interpolazione
c 
c  PARAMETRI DI OUTPUT:
c
c  -     a, vettore di reali,  coefficienti del polinomio
c  - ifail,           intero,  indicatore di errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna
c
       integer n,ifail
       real x(n),y(n),a(n)
       
c     Controllo del numero dei punti
       if (n .le. 0  .or.  n .gt. 9) then
          ifail=11
          goto 999
       endif

c     Controlla che tutte le ascisse siano distinte   
       do i=1,n
          do j=i+1,n
             if (x(i)-x(j) .eq. 0) then
                ifail=12
                goto 999
             endif
          end do
       end do

c     Inizializzazione del vettore a 
       do i=1,n
          a(i)=y(i)
       end do
   
       do k=1,n-1
          do i=1,n-k
             a(i)=(a(i+1)-a(i))/(x(i+k)-x(i))
          end do
       end do
   
       ifail=0

  999  continue
      
      End
      stop