      real function espon(x,tol,ifail)
c
c  SCOPO: calcolo dell' esponenziale di un numero. 
c        
c  PARAMETRI DI INPUT:  
c 
c  -   x,  reale,  punto in cui calcolare la funzione
c  - tol,  reale,  tolleranza richiesta
c 
c  PARAMETRI DI OUTPUT:
c
c  - espon,   reale,  valore della funzione in x
c  - ifail,  intero,  indicatore d'errore
c   
c  ROUTINES RICHIAMATE:
c
c  - tolm,  funzione reale,  tolleranza minima relativa
c
       real tolm
       external tolm
       
       real x,tol
       integer ifail

       integer n
 
c     Controllo della tolleranza        
       if (tol .lt. 0) then
          ifail=1
          goto 999
       endif
       
       vax=abs(x)
       sum=0
       add=1
       n=0              
       
   10  continue
          sum=sum+add
          n=n+1
          add=add*(vax/n)
       if (add .ge. (tol*sum+tolm(sum))) goto 10
      
c      x>0 espon=exp(x)
       if(add .ge. 0) then 
          espon=sum
c      x<0 espon=exp(-x)         
       else
          espon=1/sum
       endif   
       
       ifail=0                                         
       
  999  continue    
       
      End     
