      Subroutine lub(a,lda,n,p,q,ifail,log)
c
c  SCOPO: fattorizzazione di una matrice quadrata a banda A nella
c         forma A=L*U, dove L  una matrice triangolare inferiore
c         a diagonale unitaria e U triangolare superiore.
c
c  PARAMETRI DI INPUT:
c
c  -   a,  matrice di reali,  matrice da fattorizzare
c  - lda,            intero,  leading dimension di a dichiarata
c                             nel programma chiamante
c  -   n,            intero,  ordine della matrice
c  -   p,            intero,  ampiezza della banda inferiore
c  -   q,            intero,  ampiezza della banda superiore
c
c  PARAMETRI DI OUTPUT:
c
c  -     a,  intero,  matrice fattorizzata
c  - ifail,  intero,  indicatore di errore
c
c  ROUTINE RICHIAMATE:
c
c  - nessuna
c
       integer n,p,q,ifail,ii,jj,amp
       real a(lda,n)
                                    
       amp=p+q+1
                                           
c  Controllo della dimensione
       if (n .le. 0  .or.  n .gt. lda) then
          ifail=3
          goto 999
       endif
       
c  Controllo delle ampiezze di banda
       if (p .le. 0 .or. q .le. 0 .or. p .ge. n .or. q .ge. n) then
          ifail=6
          goto 999
       endif

      write(log,*)'fattorizzazione'       
c      Fattorizzazione
       do 40 k=1,n-1
       
          do 10 i=k+1,min(k+p,n)                  
c        Controllo della singolarit di un minore principale             
             if (a(q+1,k) .eq. 0) then
                ifail=7
                goto 999
             endif                 
             
             ir=i-k+q+1  
c        Calcolo dei moltiplicatori   
             write(log,*)'calcolo dei moltiplicatori'       

             a(ir,k)=a(ir,k)/a(q+1,k)    
             
             write(log,*)'matrice temporanea'
             do ii=1,amp
                  write(log,*)(a(ii,jj), jj=1,n)
             end do     
             
   10     continue
c        fine calcolo moltiplicatori
   
          write(log,*)'calcolo valori'
          
          do 30 j=k+1,min(k+q,n)
             do 20 i=k+1,min(k+p,n)
                ir=i-j+q+1      
                a(ir,j)=a(ir,j)-a(i-k+q+1,k)*a(k-j+q+1,j)

   20         continue
   30     continue
   40  continue
       
       write(log,*)'matrice finale'
       do ii=1,amp
           write(log,*)(a(ii,jj), jj=1,n)
       end do                          
       
       ifail=0
     
  999  continue
     
      stop
       End
   
