      Subroutine lup(a,lda,n,ipiv,ifail)
c
c  SCOPO: fattorizzazione di una matrice quadrata A nella forma
c         PA=LU, dove P  la matrice delle permutazioni derivante
c         dall' applicazione del pivoting, L una matrice triango-
c         lare inferiore a diagonale unitaria e U triangolare su-
c         periore.
c 
c  PARAMETRI DI INPUT:  
c 
c  -   a,  matrice di reali,  matrice da fattorizzare
c  - lda,            intero,  leading dimension di a dichiarata 
c                             nel programma chiamante
c  -   n,            intero,  ordine della matrice
c 
c  PARAMETRI DI OUTPUT:
c
c  -     a,   matrice di reali,  permutate le righe secondo ipiv
c                                restituisce i fattori L ed U 
c  -  ipiv,  vettore di interi,  indici delle righe di a da per-
c                                mutare per ottenere L ed U
c  - ifail,             intero,  indicatore di errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna.
c  
       integer lda,n,ipiv(n),ifail
       real a(lda,n)
      
c     Controllo della dimensione 
       if (n .le. 0 .or. n .gt. lda) then
          ifail=3
          goto 999
       endif

c     Inizializzazione di ipiv
       do 10 i=1,n
          ipiv(i)=i
   10  continue

       do 60 k=1,n

c     Ricerca del pivot
          p=abs(a(ipiv(k),k))
          m=k
          do 20 i=k+1,n
             if (abs(a(ipiv(i),k)) .gt. p) then
                p=abs(a(ipiv(i),k))
                m=i
             endif  
   20     continue

c     Controllo della singolarit
          if (p .eq. 0) then
             ifail=4
             goto 999
          endif 

c     Scambio virtuale 
          if (m .ne. k) then
             temp=ipiv(m)
             ipiv(m)=ipiv(k)
             ipiv(k)=temp
          endif

c     Calcolo dei moltiplicatori
          do 30 i=k+1,n
             a(ipiv(i),k)=a(ipiv(i),k)/a(ipiv(k),k)
   30     continue  
          
          do 50 j=k+1,n
             do 40 i=k+1,n 
                a(ipiv(i),j)=a(ipiv(i),j)-a(ipiv(i),k)*a(ipiv(k),j)
   40        continue          
   50     continue
           
   60  continue
       
       ifail=0
       
  999  continue

      end
	stop