      Subroutine slup(lu,x,p,b,ldlu,n,ifail,log)
c                                                                
c  SCOPO: risoluzione di un sistema lineare A*x=b mediante la ri-
c         soluzione del sistema equivalente (L*U)*x=P*b, dove P 
c          una matrice di permutazione ed L*U  la fattorizza-
c         zione di P*A.
c 
c  PARAMETRI DI INPUT:  
c 
c  -   lu,   matrice di reali,  permutate le righe secondo p
c                               restituisce i fattori L ed U 
c  -    p,  vettore di interi,  indici delle righe di a da 
c                               permutare per ottenere L ed U   
c  -    b,   vettore di reali,  termini noti
c  - ldlu,             intero,  leading dimension di lu dichia-
c                               rata nel programma chiamante
c  -    n,             intero,  ordine del sistema 
c
c  PARAMETRI DI OUTPUT:
c
c  -     b,  vettore di reali,  soluzione del sistema
c  - ifail,            intero,  indicatore di errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna.
c
       integer ldlu,n,p(n),ifail
       real lu(ldlu,n),b(n),x(n),somma
      
c     Controllo della dimensione
       if (n .le. 0  .or.  n .gt. ldlu) then
         ifail=3
         goto 999
       endif                   
                           
c     Controllo della singolarit
       do i=1,n
          if (lu(p(i),i) .eq. 0) then
             ifail=4
             goto 999
          endif            
       end do
          
c     Risoluzione di L*y=P*b (con y=U*x)
       x(1)=b(p(1))
       do 20 i=2,n
          somma=0                
          do 30 j=1,i-1
              somma=somma+lu(p(i),j)*b(j)
   30     continue
       x(i) = b(p(i))-somma
   20  continue
   
       
c     Risoluzione di U*x=y 
       b(n)=b(n)/lu(p(n),n)
       do 40 i=n-1,1,-1
          somma=0
          do 50 j=n,1,-1
              somma=somma+lu(p(i),j)*b(j)
   50     continue
       b(i)=(b(i)-somma)/lu(p(i),i)
   40  continue
   
       ifail=0
  
  999  continue
      
      end
	stop