      Subroutine slut(d,e,f,b,n,ifail)
c
c  SCOPO: risoluzione di un sistema lineare tridiagonale A*x=b me-
c         diante la risoluzione del sistema equivalente (L*U)*x=b,
c         dove L*U  la fattorizzazione di A.
c
c  PARAMETRI DI INPUT:
c
c  - d,  vettore di reali,  diagonale principale di U
c  - e,  vettore di reali,  diagonale inferiore di L
c  - f,  vettore di reali,  diagonale superiore di U 
c  - b,  vettore di reali,  colonna dei termini noti
c  - n,            intero,  ordine del sistema
c
c  PARAMETRI DI OUTPUT:
c
c  -     b,  vettore di reali,  soluzione del sistema
c  - ifail,            intero,  indicatore di errore
c
c  ROUTINE RICHIAMATE:
c  
c  - nessuna.
c
       integer n,ifail
       real d(n),e(2:n),f(n-1),b(n)
       
c     Controllo della dimensione
       if (n .le. 0) then
          ifail=3
          goto 999
       endif
       
c     Controllo della singolarit di U
       do 10 i=1,n  
          if (d(i) .eq. 0) then
             ifail=4
             goto 999
          endif
   10  continue
   
c     Risoluzione di L*y=b (con y=U*x)
       do 20 i=2,n
          b(i)=b(i)-e(i)*b(i-1)
   20  continue
       
c     Risoluzione di U*x=y 
       b(n)=b(n)/d(n)
       do 30 i=n-1,1,-1
             b(i)=(b(i)-f(i)*b(i+1))/d(i)
   30  continue

       ifail=0
  
  999  continue
      
      stop
      End 
      
             